<h3 align="center">
  <img src="assets/cnn_explainer_icon_web.png" width="300">
</h3>

# CNN Explainer

CNN Explainer is PyTorch based project that aims to make CNN's predictions explainable.

Check the corresponding articles:
<br>
[CNN Explainer - Interpreting Convolutional Neural Networks (1/N) Generating Area Importance Heatmaps with Occlusions](https://gsurma.medium.com/cnn-explainer-interpreting-convolutional-neural-networks-1-n-e81c62cbb660)
<br>
[CNN Explainer - Interpreting Convolutional Neural Networks (2/N) Visualizing Gradient Weighted Class Activations with GradCAM](https://gsurma.medium.com/cnn-explainer-interpreting-convolutional-neural-networks-2-n-18e40a03eae2)
<br>
[CNN Explainer - Interpreting Convolutional Neural Networks (3/N) Visualizing Boosted Convolutional Features](https://gsurma.medium.com/cnn-explainer-interpreting-convolutional-neural-networks-3-n-de0b348caff)
<br>

## Boosted Features Visualizations
[Notebook](cnn_features_visualizations.ipynb)

<img src="test_images/candle.jpg" width=224>
<img src="features_visualizations/candle.png" width=224>

---

<img src="test_images/toucan.jpg" width=224>
<img src="features_visualizations/toucan.png" width=224>

---

<img src="test_images/baseball.jpg" width=224>
<img src="features_visualizations/baseball.png" width=224>

---

<img src="test_images/chain.jpg" width=224>
<img src="features_visualizations/chain.png" width=224>

---

<img src="test_images/claw.jpg" width=224>
<img src="features_visualizations/claw.png" width=224>

---

<img src="test_images/knot.jpg" width=224>
<img src="features_visualizations/knot.png" width=224>

---

<img src="test_images/mug.jpg" width=224>
<img src="features_visualizations/mug.png" width=224>

---

<img src="test_images/screw.jpg" width=224>
<img src="features_visualizations/screw.png" width=224>

---

<img src="test_images/stingray.jpg" width=224>
<img src="features_visualizations/stingray.png" width=224>

---

<img src="test_images/tarantula.jpg" width=224>
<img src="features_visualizations/tarantula.png" width=224>

---

<img src="test_images/trombone.jpg" width=224>
<img src="features_visualizations/trombone.png" width=224>

---


## GradCAM Heatmaps
[Notebook](cnn_gradcam_heatmaps.ipynb)

Submarine
<br>
<img src="gradcam_heatmaps/gradcam_overlay_submarine.png">

<br>

Aircraft Carrier
<br>
<img src="gradcam_heatmaps/gradcam_overlay_aircraft_carrier.png">



## Area Importance Heatmaps with Occlusions
[Notebook](cnn_area_importance_heatmaps.ipynb)

<img src="area_importance_heatmaps/basketball_annotated.png">

---


<img src="area_importance_heatmaps/submarine_annotated.png">

---


<img src="area_importance_heatmaps/zebra_annotated.png">

---


<img src="area_importance_heatmaps/pineapple_annotated.png">

---


## Author

**Greg (Grzegorz) Surma**

[**PORTFOLIO**](https://gsurma.github.io)

[**GITHUB**](https://github.com/gsurma)

[**BLOG**](https://medium.com/@gsurma)
